/*
ms_unipolar_drv v. d983.2019.03.09
Библиотека для низкокоуровневого управления 
бесколлекторными моторами (включая однополюсные и двухполюсные шаговые)
с использованием MotorShield для Arduino
() Copyleft GNU GPL v.3 dron983 and others
*/

#include <Arduino.h>

#ifndef ms_unipolar_drv
#define ms_unipolar_drv
 

 
class TUniPolar {
	public:
	  TUniPolar (int h1, int e1, int h2, int e2);
      void uniStep  (bool dir); // Переключение обмоток для одного шага в цифровом одношаговом режиме в зависимости от текущего состояния
	  void uniStepA (bool dir); // Переключение обмоток для одного шага в ШИМ  режиме в зависимости от текущего состояния
	  void uniStopA (int denum); // Останов двигателя со снижением тока в ШИМ режиме
	  void uniUnlock();   // Снятие напряжения с обмоток (разблокировка)
	  float readStep ();  // Чтение счётчика шагов
	  void clearStep ();  // Сброс счётчика шагов
	  float readCoord ();  // Чтение координаты (в шагах)
	  void clearCoord ();  // Сброс координаты (в шагах)
	  void setModeA_1 ();  // Установка полношагового режима ШИМ
	  void setModeA_2 ();  // Установка полушагового режима ШИМ
	  void setModeA_4 ();  // Установка четвертьшагового режима ШИМ
	  void setModeA (int stArr[][4], int stCount); // Установка произворльного режима ШИМ
	protected:
	  int anState; // Номер текущего состояния переключения обмоток
	  int* getCurrStA(); // Получение текущего массива состояния обмоток в  режиме ШИМ
	  int* getNextStA(bool dir); // Получение следующего массива состояния обмоток в  режиме ШИМ
	  // H# - признак изменения полярности выхода #
      // Е# - включение выхода #
	  int H1, E1, H2, E2; // Номера разъёмов для управления платой 
	  float anStep; // Счётчик количества шагов (с момента сброса)
	  float anCoord;   // Коррдината положения в циклах шагов  (с точки сброса)
	  void doStepD(boolean stStr[4]);
	  void doStepA (int stStr[4]);
	  void doUnlock_();
	  int getStep();
	  int (*stepArray)[4];
	  int stepCount;
	  
};
 
#endif
